close all; clear;
addpath(genpath('./func'))


data = "syn";
N1 = 300;
N2 = 300;
N3 = 400;
[X0, L1, D, Y0, W0, R, rdg, rdt] = syn_data_gen(N1, N2, N3, "Rama");

sd = std(X0(:));

snr = 10;
nsr = 1/snr;
noise = nsr * sd .* (randn(size(X0))-0.5);
X = X0 + noise;

%%
atom_selection_rate = 100 / (1000 + 774); % GT_atoms / total_atoms
k_atoms = 5;
power = 1;
g_groups = 3;
solver = 1;

%% LRMDS
[Ys, Ws, selectedIs, selectedJs, times] = LRMDS(X, D, R, atom_selection_rate, k_atoms, power, g_groups, solver);
time_LRDS = cumsum(sum(times));
for i = 1:length(Ys)
    Yi = Ys{i};
    Wi = Ws{i};
    Yi(abs(Yi)<1e-10) = 0;
    Wi(abs(Wi)<1e-10) = 0;
    Xrec = D * Yi * Wi * R;
    rmse_LRMDS(i) = rmse(Xrec(:), X(:));
    natoms_LRMDS(i) = sum(sum(Yi,2)~=0) + sum(sum(Wi,1)~=0);
end

%% LRMDS fast
[Ys, Ws, selectedIs, selectedJs, times] = LRMDS_fast(X, D, R, atom_selection_rate, k_atoms, power, g_groups, solver);
time_LRDS_fast = cumsum(sum(times));
for i = 1:length(Ys)
    Yi = Ys{i};
    Wi = Ws{i};
    Yi(abs(Yi)<1e-10) = 0;
    Wi(abs(Wi)<1e-10) = 0;
    Xrec = D * Yi * Wi * R;
    rmse_LRMDS_fast(i) = rmse(Xrec(:), X(:));
    natoms_LRMDS_fast(i) = sum(sum(Yi,2)~=0) + sum(sum(Wi,1)~=0);
end


