function [X, L1, D, Y0, W0, R, rdg, rdt] = syn_data_gen(N1, N2, N3, opt)

gt_atoms_count = 50;
k_groups = 3;

N = N1 + N2 + N3;
[L1] = createL(N1,N2,N3);

while anynan(L1) 
    [L1] = createL(N1,N2,N3);
end

[D,~]= eigs(L1, N, 'smallestabs');  

t = 2000;

if opt == "Rama"   
    max_period = 50;
    Phi=Create_Dictionary(max_period, t, 'Ramanujan');
    R=Phi';
elseif opt == "Spline"
    Phi=construct_spline_dictionary([1:t], 2000, 8);
    R=Phi';
else % DFT
    R = (1/(t^(1/2)))*dftmtx(t);
end

SN = size(D,2);
SM = size(R,1);

rdg = randsample(SN, gt_atoms_count);
rdt = randsample(SM, gt_atoms_count);
Y0 = zeros(SN, k_groups);
Y0(rdg, :) = rand(gt_atoms_count, k_groups);
W0 = zeros(k_groups, SM);
W0(:,rdt) = rand(k_groups, gt_atoms_count);

X = D * Y0 * W0 * R;
end

function [L, adj] = createL(N1,N2,N3)
    N = N1 + N2 + N3;
    
    [A0] = construct_graph(N,'er',0.02);
    [A1] = construct_graph(N1,'er',0.2);
    [A2] = construct_graph(N2,'er',0.2);
    [A3] = construct_graph(N3,'er',0.2);
    A0 = full(A0);
    A1 = full(A1);
    A2 = full(A2);
    A3 = full(A3);
    
    A = A0;
    A(1:N1,1:N1) = A1;
    A((N1+1):(N1+N2),(N1+1):(N1+N2)) = A2;
    A((N1+N2+1):(N1+N2+N3),(N1+N2+1):(N1+N2+N3)) = A3;
    
    A(A>0)=1;
    adj = A;
    degree = sum(adj);
    Degree = diag(degree);
    L = (Degree - adj);
    L = Degree^(-0.5) * L * Degree^(-0.5);  % L-normalized
end